#! ruby -Ku
##made by tak2hata  http://onigiriburning.so.land.to/
##since 2013/03/07
##update2013/03/24
##update2013/05/16:Sketchup extension class.
##update2013/08/31:Improve UI.
##update2013/09/15:New Option for changing Sketchup Scene Page by clicking Annotater TAB.
##Annotator
##日本語対応

require 'sketchup.rb'
begin
	require 'nkf';$nkfexist = true
rescue LoadError
	$nkfexist = false
end
module TAK2HATA::T2H_Annotator
##################################################
class Annotator
	class TAK_view_animation
		@@psec = 0.to_f
		def initialize( tent , txt )
			@tent = tent
			@txt = txt
			@@tlen = 0
		end
		def nextFrame(view)
			@@tlen += 1
			Sketchup.active_model.active_view.animation = nil if @@tlen > @txt.split(//u).length
			txt2 = @txt.split(//u)[0,@@tlen]
			@tent.text = txt2.join
			@@psec = Time.now.to_f
		end
	end#class
	def charconv_on_OS( txt )
		htmlcode = '<!DOCTYPE html><html><head><meta http-equiv="Content-Type" content="text/html; charset=ANSI" /><title>Charset Convert</title></head><body></body></html>'
		prfkeys = { 
			:dialog_title => 'Charset Convert', 
			:scrollable => true, 
			:preferences_key => 'Charset Convert', 
			:height => 100, 
			:width => 100, 
			:left => 0, 
			:top => 0, 
			:resizable => false
		} 
		wdlg = UI::WebDialog.new( prfkeys )
		wdlg.set_html( htmlcode )
		wdlg.add_action_callback("send_text"){|d,prm|
			wdlg.close
			@conv_filename = prm
		}
		wdlg.show_modal{
			txt.gsub!(/\\/,"/")
			jcmd = 'window.location= "skp:send_text@" + "' + txt + '";'
			wdlg.execute_script(jcmd)
		}
	end
	def char_conv( txt = "")
		return "" if txt == nil
		if RUBY_PLATFORM[/darwin/]
			return txt
		else
			if $nkfexist == true
				return NKF.nkf('-Wsx', txt)
			else
				charconv_on_OS( txt )
				return @conv_filename
			end
		end
	end
	def add_annotate_text(txt, indx = -1 )
		model = Sketchup.active_model
		ents = model.entities
		easymode = true
		#tlist = ents.find_all{|e| e.kind_of? Sketchup::Text and e.layer.visible? == true and e.visible? == true }
		tlist = ents.find_all{|e| e.kind_of? Sketchup::Text and e.layer.visible? == true and e.get_attribute("annotatoer", "is_annotate") == "yes"}
		klist = []
		if tlist and tlist != []
			klist = tlist.find_all{|e| e.visible? == true }
		end
		if klist.size == 1
			#if po == "ON"
			#	Sketchup.active_model.active_view.animation = TAK_view_animation.new( klist[0] ,txt )
			#else
				klist[0].visible = true
				klist[0].text = txt
			#end
		else
			ents.erase_entities( klist ) if klist
			return if txt == ""
			view = model.active_view
			dfs = model.definitions
			@ann_name = "annotator_text" if not @ann_name
			cdf = dfs["annotator_text"]
			if not cdf
				#p "add annotator_text"
				pdir = File.dirname( File.expand_path(__FILE__) )
				path=File.join(pdir, "annotator_text.skp")
				cdf = dfs.load( path )
				@ann_name = cdf.name# = "annotator_text"
				#p cdf.name
			end
			w = view.vpwidth
			h = view.vpheight
			ray = view.pickray( 40,40 )#( w / 10.0 ) , ( h / 10.0 ) )
			camera = view.camera
			target = camera.target
			cvec = camera.direction
			plane = [ target , cvec ]
			pt = Geom.intersect_line_plane(ray, plane)
			tr = Geom::Transformation.new( pt )
			ci = ents.add_instance( cdf, tr )
			ctent = cdf.entities.find{|e| e.kind_of? Sketchup::Text }
			ctent.set_attribute( "annotatoer", "is_annotate", "yes" )
			#if indx != -1
			#	ctent.set_attribute( "annotatoer", "scene_index", indx )
			#end
			#ctent.text = txt
			cents = ci.explode
			#ctent2 = cents.find{|e| e.kind_of? Sketchup::Text and e.get_attribute("annotatoer", "is_annotate") == "yes" }
			#if po == "ON"
			#	Sketchup.active_model.active_view.animation = TAK_view_animation.new( ctent2 ,txt )
			#else
			ctent.text = txt
			#end
		end
	end
	def add_menu()
		tak_ann_menu = UI.menu("Plugins").add_submenu("Annotator")
		tak_ann_menu.add_item( "Show dialog" ){
			show_webdialog()
		}

		tak_ann_menu.add_item( "About This" ) { 
		UI.messagebox("Annotator
ver1.0(Update:Mar 24,2013)
By TAK2HATA
General disclaimer
I MAKES NO GUARANTEE OF VALIDITY about this script.
Please use this script at your own risk.
免責事項
このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
")	}
	end
	def show_webdialog()
		prfkeys = { 
			:dialog_title => 'Annotator', 
			:scrollable => true, 
			:preferences_key => 'TAK2_ANNOTATOR', 
			:height => 300, 
			:width => 600, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		wdlg = UI::WebDialog.new( prfkeys)
		#wdlg.set_html( htmlcode() )
		wdlg.set_file( File.join(File.dirname( __FILE__ ),"webdialog.html"))
		wdlg.add_action_callback("show_text"){|dlg,po|
			txt = wdlg.get_element_value("TEXTAREA")
			chk = wdlg.get_element_value("change_scene_page")
			#p chk
			indx = -1
			if po and po != "" and chk == "true"
				indx = po.to_i
				#p po
				add_annotate_text( txt ,indx )
				pages = Sketchup.active_model.pages
				if pages[indx]
					pages.selected_page = pages[indx]
				else
					indx = -1
				end
			else
				add_annotate_text( txt ,indx )
			end
		}
		wdlg.add_action_callback("savelist"){|dlg,po|
			filepath_o = UI.savepanel "Export text File", "", "*.txt"
			return false if filepath_o == nil #case CANSEL
			filepath = char_conv( filepath_o )
			if File.extname( filepath ).downcase != ".txt"
				filepath = filepath + ".txt"
			end
			f = open( filepath , "w+" )
			buff = wdlg.get_element_value("TEXTAREA")
			f.puts buff
			f.close
		}
		wdlg.add_action_callback("loadlist"){|dlg,po|
			filepath_o = UI.openpanel "Import text File", "", "*.txt"
			return false if filepath_o == nil #case CANSEL
			cmd = "tabsclear();"
			wdlg.execute_script( cmd )
			filepath = char_conv( filepath_o )
			if File.extname( filepath ).downcase == ".txt"
				f = open( filepath , "r" )
				l = 0
				tbuff = f.read.split("\r\n")
				tbuff.each{|line1|
					line1.chomp!
					line1.gsub!(/\"/,'\"')
					p line1
					if line1 != ""
						##cmd = 'document.getElementById("TEXTLIST").options[' + l.to_s + ']= new Option( "' + line1 + '" ,' + l.to_s + ');'
						cmd = 'add_tab_value("' + line1.gsub("||","\\n") + '");'
						wdlg.execute_script( cmd )
						l += 1
					end
				}
				f.close
			end
		}
		if RUBY_PLATFORM[/darwin/]
			wdlg.show_modal
		else
			wdlg.show
		end
	end

end#class
if not file_loaded?( "t2h_annotator.rb" )
	tak_ann = Annotator.new
	tak_ann.add_menu()
end
end#module

file_loaded("t2h_annotator.rb")
